<?php
/*
  Plugin Name: External link to Js
  Plugin URI:  http://www.freearticlespinning.com/external-link-to-js/
  Description: Convert external to js clickable link, support exclude domain.
  Version: 1.1
  Author: MrNo
  Author URI:  http://www.freearticlespinning.com/
 */
###############################################
include('ext2js-options.php');
add_action('admin_menu', 'ext2js_admin_menu');

###############################################
//--------------------------------------------------------------------------------------------------
function ext2js_admin_menu() {
    add_options_page('Ext2Js Options', 'Ext2Js Options', 'manage_options', 'ext2js_options', 'ext2js_options');    
}
//--------------------------------------------------------------------------------------------------

function ext2js_links_to_js($content, $exclude_domain = array()){
    //print_r($exclude_domain);
    
    $pattern = "~(<a href=(\"|'))(.*?)(\"|')(\s*)(>)(.+?)(<\/a>)~e";
    $pattern = "~<a (.*?)>(.*?)<\/a>~sie";
    $match = array();
    // Get all a tag
    preg_match_all($pattern, $content, $match);
    if(isset($match[0])){
        $a_links = $match[0];
        //print_r($match);
        
        //print_r($a_links);
        $dom = new DomDocument;
        foreach($a_links as $link){
            $dom->loadHTML($link);
            $elements = $dom->getElementsByTagName('a');
            $item = $elements->item(0);
            $href = $item->getAttribute('href');
            
            // Exclude domain to be converted
            $is_excluded = FALSE;
            if(count($exclude_domain)){
                $parse = parse_url($href);
                $host = $parse['host'];
                $pattern = '~'. implode('|',$exclude_domain) .'~i';
                if(preg_match($pattern,$host)){
                    $is_excluded = TRUE;
                }
            }
            
            if(!$is_excluded){
                $finds = array("href='".$href."'", 'href="'.$href.'"');
                $replace = "onClick=\"javascript:window.open('$href')\" href=\"javascript:void(0);\" ";
                $new_link = str_replace($finds,$replace,$link);
                // remove target=_blank
                $a_blank = array('target=_blank','target="_blank"',"target='_blank'");
                $new_link = str_replace($a_blank,"", $new_link);
                $content = str_replace($link, $new_link, $content);
            }
        }
    }
    return $content;
}

function ext2js_the_content_link_to_js($text){
    global $wpdb;
    $ex_domains = get_option('ext2js_exclude_domains');
    $ex_domains = str_replace("\r",'',$ex_domains);
    $a_ex_domains = explode("\n",$ex_domains);
    
    // Get site domain
    $parse = parse_url(site_url());
    $a_ex_domains[] = $parse['host'];
    
    foreach($a_ex_domains as $key => $domain){
        if(trim($domain) == '')
            unset($a_ex_domains[$key]);
    }
    return ext2js_links_to_js($text,$a_ex_domains);    
}

add_filter('the_content', 'ext2js_the_content_link_to_js', 10);
?>